# Master 2 ID3D - Analyse, Traitement d'Image et Vision 3D
# Master 2 IA - Apprentissage Machine Et Image

Responsables de l'enseignement : [Alexandre Meyer](http://liris.cnrs.fr/alexandre.meyer), 
[Julie Digne](http://liris.cnrs.fr/jule.digne) 
et [Nicolas Bonneel](http://liris.cnrs.fr/nicolas.bonneel) - LIRIS, Université Lyon 1

Volume horaire : 30h (CM/TP)


![MLImage_all.jpg](images/MLImage_all.jpg)

## Objectif de l'UE
<p style="text-align:justify;"> Cette page regroupe des supports pour des cours de 2ère année du Master d'Informatique de l'Université Lyon 1 (ATIV pour ID3D, et "Apprentissage et Image" pour IA). Les cours ont lieu à l'automne. L'objectif de l'UE est de donner les bases en apprentissage machine (notamment apprentissage profond) pour les problèmes d'images. Le cours présente d'abord les problèmes classiques liés à l'image comme la classification, l'extraction de descripteurs, la reconnaissance de formes, le suivi d'objet, la segmentation, etc. Puis le cours présente les méthodes génératives autour de l'image au sens large. Un large panel des différents types de réseaux (CNN, auto-encoder, LSTM, GAN, transformer, réseaux de diffusion, etc.) est donné en se focalisant sur des données de type image, mais également des données de type nuage de points, maillage, animation (squelette), palette de couleur, etc.
</p>

[Les slides de la présentation des options en Master IA sont ici.](doc/MLImage_PresOption.pdf)


## Thématiques abordées

### Deep learning et images
  * Les bases de l'apprentissage profond : entrainement, espace latent, régularisation, etc.
  * ConvolutionNN
  * Segmentation (U-Net, etc.)
  * Tracking (YOLO)
  * Capture du squelette (OpenPose, XNect, etc.)
  * Notion de transformer/attention pour la reconnaissance

### Deep learning génératif
  * Génération d'images
    * auto-encoder
    * GAN
    * Réseaux de diffusion
  * Notions étendues à des données 3D
  
### Deep learning géometrique
  * Apprentissage pour les données géométriques :
     * Nuages de points (pointNet, etc.)
     * Maillages (MeshConv, etc.)
     * Diffusion sur les surfaces
  * Représentations neuronales implicites (IGR, SIREN)
  * Champs de radiance neuronaux (Nerf)

### Transport optimal
  * Introduction au transport optimal
  


## Emploi du temps : automne 2024

Pour le Master IA, les cours/tp sont les jeudis après-midi entre octobre et janvier. Pour les ID3D, il y a des cours les mardis matins de septembre, puis en octobre les CM sont les jeudis après-midi et les TP les mardis matins.



## Modalités de contrôle des connaissances (MCC)
 - Partie NB : évaluation du TP
 - Partie AM : examen papier et évaluation du TP "génération d'image à partir d'une pose"
 - Partie JD : examen papier

